package datumservice.impl;

import java.text.SimpleDateFormat;
import java.util.*;
import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;
import org.osgi.service.component.ComponentContext;
import datumservice.DatumService;

public class DatumServiceImpl implements DatumService
{
   protected void activate( ComponentContext componentContext )
   {
      System.out.println( "\nDatumServiceImpl aktiviert mit folgenden Spezial-Properties:" );
      System.out.println( "   MeinCompDescrSpezialKey = " +
            componentContext.getProperties().get( "MeinCompDescrSpezialKey" ) );
      System.out.println( "   MeinPropSpezialKey      = " +
            componentContext.getBundleContext().getProperty( "MeinPropSpezialKey" ) );
      System.out.println( "   MeinBundleMfSpezialKey  = " +
            componentContext.getBundleContext().getBundle().getHeaders().get( "MeinBundleMfSpezialKey" ) );
      printComponentContextProperties( componentContext );
   }

   protected void deactivate( ComponentContext componentContext )
   {
      System.out.println( "DatumServiceImpl deaktiviert." );
   }

   @Override
   public String getDatum()
   {
      return (new SimpleDateFormat( "yyyy-MM-dd HH:mm" )).format( new Date() );
   }

   private static void printComponentContextProperties( ComponentContext componentContext )
   {
      final String[] BCP = { Constants.FRAMEWORK_OS_NAME, Constants.FRAMEWORK_VENDOR, "MeinPropSpezialKey" };
      System.out.println( "ComponentContext-Properties: " );
      Dictionary<?,?> props = componentContext.getProperties();
      for( Enumeration<?> keys = props.keys(); keys.hasMoreElements(); ) {
         String key = "" + keys.nextElement();
         System.out.println( "   " + key + " = " + props.get( key ) );
      }
      System.out.println( "ComponentContext-BundleContext-Properties: " );
      BundleContext bundleContext = componentContext.getBundleContext();
      for( String key : BCP )
         System.out.println( "   " + key + " = " + bundleContext.getProperty( key ) );
      System.out.println( "ComponentContext-BundleContext-Bundle-Properties: " );
      props = bundleContext.getBundle().getHeaders();
      for( Enumeration<?> keys = props.keys(); keys.hasMoreElements(); ) {
         String key = "" + keys.nextElement();
         System.out.println( "   " + key + " = " + props.get( key ) );
      }
   }
}
