package datumservice.eventsender;

import java.text.SimpleDateFormat;
import java.util.*;
import org.osgi.service.component.ComponentContext;
import org.osgi.service.event.*;

public class DatumServiceSender extends TimerTask
{
   private EventAdmin eventAdmin;
   private Timer timer;

   public void bindEventAdmin( EventAdmin eventAdmin )
   {
      this.eventAdmin = eventAdmin;
   }

   public void unbindEventAdmin( EventAdmin eventAdmin )
   {
      this.eventAdmin = null;
   }

   protected void activate( ComponentContext componentContext )
   {
      timer = new Timer();
      timer.scheduleAtFixedRate( this, 0, 5000 );
      System.out.println( "\nDatumServiceSender aktiviert." );
   }

   protected void deactivate( ComponentContext componentContext )
   {
      timer.cancel();
      System.out.println( "DatumServiceSender deaktiviert." );
   }

   @Override
   public void run()
   {
      String dateTime = (new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss" )).format( new Date() );
      Dictionary<String,String> eventProps = new Hashtable<String,String>();
      eventProps.put( "Datum/Zeit", dateTime );
      Event event = new Event( "datumservice/eventsender/Timer", eventProps );
      // "sendEvent()" fuer synchron, "postEvent()" fuer asynchron:
      eventAdmin.sendEvent( event );
   }
}
