package servlet;

import org.osgi.service.component.ComponentContext;
import org.osgi.service.http.HttpService;

public class ServletComponent
{
   protected void bindHttpService( HttpService httpService )
   {
      try {
         httpService.registerServlet(   "/meinservlet", new MeinServlet(), null, null );
         httpService.registerResources( "/", "/html", null );
         httpService.registerResources( "/img", "/images", null );
      } catch( Exception ex ) {
         ex.printStackTrace();
      }
   }

   protected void unbindHttpService( HttpService httpService )
   {
      httpService.unregister( "/meinservlet" );
      httpService.unregister( "/" );
      httpService.unregister( "/img" );
   }

   protected void activate( ComponentContext componentContext )
   {
      String port = componentContext.getBundleContext().getProperty( "org.osgi.service.http.port" );
      if( port == null || port.trim().length() == 0 ) port = "80";
      System.out.println( "ServletComponent aktiviert: http://localhost:" + port + "/MeinFormular.html" );
   }
}
