package datumservice.consumer;

import org.osgi.framework.*;
import org.osgi.util.tracker.*;
import datumservice.DatumService;

public class Activator implements BundleActivator
{
   private ServiceTracker datumServiceTracker;

   @Override
   public void start( final BundleContext context )
   {
      System.out.println( context.getBundle().getSymbolicName() +  " startet ..." );
      datumServiceTracker = new ServiceTracker( context, DatumService.class.getName(),
         new ServiceTrackerCustomizer()
         {
            @Override
            public Object addingService( final ServiceReference reference )
            {
               final DatumService datumService = (DatumService) context.getService( reference );
               if( datumService != null )
                  System.out.println( "Konsument-ServiceTracker liest Datum-Service: " + datumService.getDatum() );
               return datumService;
            }

            @Override
            public void modifiedService( final ServiceReference reference, final Object service ) {/*ok*/}
            @Override
            public void removedService(  final ServiceReference reference, final Object service ) {/*ok*/}
         });

      datumServiceTracker.open();
      System.out.println( context.getBundle().getSymbolicName() +  " gestartet und Tracker geoeffnet." );
   }

   @Override
   public void stop( final BundleContext context )
   {
      if( datumServiceTracker != null )
          datumServiceTracker.close();
      System.out.println( context.getBundle().getSymbolicName() +  " gestoppt." );
   }
}
